/*--------------------------------\
| YMenu 0.01 | Content menu       |
|---------------------------------|
| Copyright (C) 2009 Keysystems   |
| www: http://www.keysystems.ru   |
| email: yeti@na-svyazi.ru        |
|--------------------------------*/

// YMenuNode object
function Node(id,parent,text,action)
{
	this.id = id;
	this.parent = parent;
	this.text = text;
	this.childs = new Array();
	this.action = action;
};


// YMenu object
YMenu = new Object();

YMenu.init = function()
{
	if(	YMenu.topDiv != undefined || YMenu.topDiv != null )
	{
		YMenu.close();
	}

	YMenu.items = new Array();
	YMenu.unItems = new Array();
	YMenu.unItemsCnt = 0;
	YMenu.childs = new Array();
	YMenu.divs = new Array();
	YMenu.is_ie = ( (navigator.userAgent.toLowerCase().indexOf("msie") != -1) &&
					(navigator.userAgent.toLowerCase().indexOf("opera") == -1) );
}

YMenu.close = function()
{
    if(!YMenu.topDiv) return;
    
	document.body.removeChild(YMenu.topDiv);
	YMenu.topDiv=null;

    //     , .. DIV  
	if (YMenu.is_ie) {
		document.body.detachEvent("onclick", YMenu.onblur);
	} else {
		document.body.removeEventListener("click", YMenu.onblur, false);
	}

}

YMenu.onblur = function(ev)
{
	YMenu.close();
}

YMenu.stopEvent = function(ev)
{
	if (YMenu.is_ie) {
		window.event.cancelBubble = true;
		window.event.returnValue = false;
	} else {
		ev.preventDefault();
		ev.stopPropagation();
	}
}

YMenu.onclickAction = function(ev)
{
	var se = YMenu.getSrcElement(ev);
	if(se.jsaction)
	{
		YMenu.close();
		eval(se.jsaction);
	}
}

YMenu.onclick = function(ev)
{
	YMenu.stopEvent(ev);
}

YMenu.addItem = function(id, parent, text, action)
{
	if (id < 0)
	{
		id = YMenu.aNodes.length;
	}

    //--
	if(YMenu.unItems[id] != undefined)
	{
		id = YMenu.unItems[id];
	}
	else
	{
		YMenu.unItems[id]=YMenu.unItemsCnt++;
		id = YMenu.unItems[id];
	}

	if(parent>0)
	{
		if(YMenu.unItems[parent] != undefined)
		{
			parent = YMenu.unItems[parent];
		}
		else
		{
			YMenu.unItems[parent]=YMenu.unItemsCnt++;
			parent = YMenu.unItems[parent];
		}
	}
    //--

	YMenu.items[id] = new Node(id, parent, text, action);
}

YMenu.render = function()
{
	for(var i=0;i<YMenu.items.length;i++)
	{
		YMenu.items[i].childs = new Array();
	}

	YMenu.childs = new Array();

	for(var i=0;i<YMenu.items.length;i++)
	{
		var parent = YMenu.items[i].parent;

		if(parent >= 0)
		{
			YMenu.items[parent].childs[YMenu.items[parent].childs.length] = YMenu.items[i];
		}
		else
		{
			YMenu.childs[YMenu.childs.length] = YMenu.items[i];
		}
	}

	YMenu.divs = new Array();
}

YMenu.getSrcElement = function(ev)
{
	if(YMenu.is_ie){
		return window.event.srcElement;
	}else{
		return ev.currentTarget;
	}
}

YMenu.fillMenu = function(itemSub)
{
	var elem = document.createElement("DIV");

    //   
	var div_id = YMenu.divs.length;
	elem.id = "YMenu_div_"+div_id;
	elem.className = "YMenu_div";
	YMenu.divs[ div_id ] = elem;

	for(var i=0;i<itemSub.childs.length;i++)
	{
		var itemClass = "YMenu_item"; if(!i) {itemClass+="_first";}

		var elemItem = document.createElement("DIV");

		elemItem.itemHasChilds = false;
		elemItem.YMenu_elem = elem;

		if(itemSub.childs[i].childs.length>0)
		{
			itemClass+=" YMenu_hasChild";

			elemItem.itemHasChilds = true;
			elemItem.YMenu_itemid = itemSub.childs[i].id;
		}

		if(itemSub.childs[i].action != undefined)
		{
			itemClass+=" YMenu_hasAction";
			elemItem.jsaction = itemSub.childs[i].action;
			elemItem.onclick = YMenu.onclickAction;
		}
		elemItem.onmouseover = YMenu.showSub;

		elemItem.className = itemClass;
		elemItem.innerHTML = itemSub.childs[i].text;

		elem.appendChild(elemItem);
	}

	return elem;
}

//  mouseover  .
YMenu.showSub = function(ev)
{
	// 
	var se = YMenu.getSrcElement(ev);
	//id  
	var parentid = se.YMenu_itemid;
	// (DIV)  
	var parentMenu = se.YMenu_elem;

	if(parentMenu.YMenu_lastSelectedChild)
	{
		YMenu.removeClass(parentMenu.YMenu_lastSelectedChild,"YMenu_selected");
	}
	YMenu.addClass(se, "YMenu_selected");
	parentMenu.YMenu_lastSelectedChild=se;

	//    
	var bdel=0;
	for(var i=YMenu.divs.length-1;i>=0;i--)
	{
		if(YMenu.divs[i].id==parentMenu.id) break;
		YMenu.divs[i].parentNode.removeChild(YMenu.divs[i]);
		YMenu.divs.pop();
	}

    //    - 
    if(se.itemHasChilds)
    {
	    //-
		var itemSub = YMenu.items[parentid];

	    var elem = YMenu.fillMenu(itemSub);

		var y=parentMenu.offsetTop+se.offsetTop;
		var x=parentMenu.offsetLeft+parentMenu.clientWidth;

		YMenu.topDiv.appendChild(elem);

		//Y
		if(elem.offsetHeight+y<=document.body.clientHeight){
			elem.style.top = y;
		}else{
			elem.style.top = y-elem.offsetHeight+se.offsetHeight;
		}
        //X
		if(elem.offsetWidth+x<=document.body.clientWidth){
			elem.style.left = x;
		}else{
			elem.style.left = parentMenu.offsetLeft-elem.offsetWidth;
		}
	}
}

YMenu.show = function(x,y)
{
	YMenu.render();

	YMenu.topDiv = document.createElement("DIV");
	YMenu.topDiv.id = "YMenu";

	var elem = YMenu.fillMenu(YMenu);

	elem.style.top = 0;
	elem.style.left = 0;

	YMenu.topDiv.appendChild(elem);
	YMenu.topDiv.onclick = YMenu.onclick;

	document.body.appendChild(YMenu.topDiv);

	elem.style.position = 'absolute';
	if(elem.offsetHeight+y<=document.body.clientHeight){
		elem.style.top = y;
	}else{
		elem.style.top = y-elem.offsetHeight;
	}
	if(elem.offsetWidth+x<=document.body.clientWidth){
		elem.style.left = x;
	}else{
		elem.style.left = x-elem.offsetWidth;
	}

	//     
	if (YMenu.is_ie) {
		document.body.attachEvent("onclick", YMenu.onblur);
	} else {
		document.body.addEventListener("click", YMenu.onblur, false);
	}
}

YMenu.getMouseCoords = function(ev)
{
	var x=y=0;
	if (YMenu.is_ie) {
		x = window.event.clientX + document.body.scrollLeft;
		y = window.event.clientY + document.body.scrollTop;
	} else {
		x = ev.clientX + window.scrollX;
		y = ev.clientY + window.scrollY;
	}
	return {x:x,y:y};
}

YMenu.removeClass = function(elem, className)
{
	var a1 = elem.className.split(" ");
	var a2 = new Array();
	for (var i = 0;i<a1.length;i++) {
		if (a1[i] != className) {
			a2[a2.length] = a1[i];
		}
	}
	elem.className = a2.join(" ");
}

YMenu.addClass = function(elem, className) {
	YMenu.removeClass(elem, className);
	elem.className+=" " + className;
}
